## libstxxl 1.4.0

=== CMakeLists.txt ===
############################################################################
#  CMakeLists.txt
#
#  Base CMake file for building stxxl with different options.
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

set(CMAKE_LEGACY_CYGWIN_WIN32 0) # needed to silence warning on cygwin

# require cmake 2.6.2 (but please use 2.8.x)
cmake_minimum_required(VERSION 2.6.2 FATAL_ERROR)

# the STXXL project
project(stxxl)

# for additional cmake scripts
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/misc/cmake)

# prohibit in-source builds
if("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
  message(SEND_ERROR "In-source builds are not allowed.")
endif()

# default to Debug building for single-config generators
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message("Defaulting CMAKE_BUILD_TYPE to Debug")
  set(CMAKE_BUILD_TYPE "Debug")
endif()

# STXXL version string
set(STXXL_VERSION_MAJOR "1")
set(STXXL_VERSION_MINOR "4")
set(STXXL_VERSION_PATCH "0")
set(STXXL_VERSION_STRING "${STXXL_VERSION_MAJOR}.${STXXL_VERSION_MINOR}.${STXXL_VERSION_PATCH}")
set(STXXL_VERSION_PHASE "prerelease/${CMAKE_BUILD_TYPE}")

# read .git directory (if it exists) and find git sha
include(GetGitRevisionDescription)
get_git_head_revision(STXXL_VERSION_GIT_REFSPEC STXXL_VERSION_GIT_SHA1)
if(STXXL_VERSION_GIT_REFSPEC)
  message(STATUS "Detected git refspec ${STXXL_VERSION_GIT_REFSPEC} sha ${STXXL_VERSION_GIT_SHA1}")
endif()

###############################################################################
# compilation options

# please document all build options in doc/install.doc:install_build_options

option(BUILD_EXAMPLES "Build all stxxl examples" OFF)

option(BUILD_TESTS "Build all stxxl test programs" OFF)
if(BUILD_TESTS)
  set(BUILD_EXAMPLES ON)
endif()

option(BUILD_EXTRAS "Build all extra stxxl tests and tool programs" OFF)

if(MSVC_VERSION LESS 1700)
  # require boost for Visual C++ versions older than VC11 = MSVS 2012
  set(USE_BOOST ON)
else()
  option(USE_BOOST "Use Boost libraries for threads,config,filesystem,random and date_time" OFF)
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  option(USE_GNU_PARALLEL "Use GNU parallel extensions for multi-core parallelism" ON)
endif()

option(TRY_COMPILE_HEADERS "Test stxxl header files for self-sufficiency: try to compile them." OFF)

if(NOT MSVC)
  option(USE_STD_THREADS "Force usage of C++ standard library thread support." OFF)
endif()

option(NO_CXX11 "Build without C++11 flags" OFF)

option(USE_VALGRIND "Run tests with valgrind, pre-initialize some memory buffers." OFF)

option(USE_GCOV "Compile and run tests with gcov for coverage analysis." OFF)

### building shared and/or static libraries

# by default we currently only build a static library, since we do not aim to
# keep a stable binary interface.
option(BUILD_STATIC_LIBS "Build static library version of libstxxl" ON)
option(BUILD_SHARED_LIBS "Build shared library version of libstxxl" OFF)

### allow user to specify other installation paths

set(INSTALL_BIN_DIR "bin" CACHE PATH "Installation directory for executables")
set(INSTALL_LIB_DIR "lib" CACHE PATH "Installation directory for libraries")
set(INSTALL_INCLUDE_DIR "include" CACHE PATH "Installation directory for header files")
set(INSTALL_PKGCONFIG_DIR "lib/pkgconfig" CACHE PATH "Installation directory for pkg-config file")

if(WIN32 AND NOT CYGWIN)
  set(DEF_INSTALL_CMAKE_DIR "CMake")
else()
  set(DEF_INSTALL_CMAKE_DIR "lib/cmake/stxxl")
endif()
set(INSTALL_CMAKE_DIR "${DEF_INSTALL_CMAKE_DIR}" CACHE PATH "Installation directory for cmake files")

###############################################################################
# enable use of "make test"

enable_testing()

include(CTest)
set(CTEST_PROJECT_NAME "STXXL")

if(USE_VALGRIND)
  set(STXXL_WITH_VALGRIND 1)
  set(VALGRIND_OPTS --leak-check=full --error-exitcode=1 --suppressions=${PROJECT_SOURCE_DIR}/misc/valgrind.supp)
endif()

###############################################################################
# enable use of "make package"

# general package settings
set(CPACK_PACKAGE_VENDOR "STXXL Maintainer Team")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Library of external memory algorithms")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE_1_0.txt")
set(CPACK_PACKAGE_VERSION_MAJOR "${STXXL_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${STXXL_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${STXXL_VERSION_PATCH}")

# source packaging
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_SOURCE_IGNORE_FILES "/\\\\..*$;/build;${CPACK_SOURCE_IGNORE_FILES}")

# binary packaging
set(CPACK_GENERATOR "TGZ")

include(CPack)

###############################################################################
# check platform

if(WIN32 OR WIN64 OR MINGW)
  set(STXXL_WINDOWS "1")
endif()

if(MSVC)
  set(STXXL_MSVC ${MSVC_VERSION})
endif()

###############################################################################
# enable warnings

if(MSVC)
  # Force to always compile with W4
  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  endif()
  ### disable verbose warnings:
  # warning C4127: conditional expression is constant
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4127")
  # warning C4290: C++ exception specification ignored except to indicate a function is not __declspec(nothrow)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4290")
  # warning C4250: '...' : inherits '...' via dominance
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4250")
  # warning C4512: assignment operator could not be generated (contains const members)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4512")
  # warning C4355: 'this' : used in base member initializer list
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4355")
  # disable lots of warnings about "unsecure" C runtime function
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  # disable lots of warnings about deprecated POSIX function names
  add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
  # disable lots of warnings about "unsecure" STL functions
  add_definitions(-D_SCL_SECURE_NO_WARNINGS)
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W -Wall -pedantic -Wno-long-long")
  # detect -Wextra
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag(-Wextra CXX_HAS_FLAGS_WEXTRA)
  if(CXX_HAS_FLAGS_WEXTRA)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra")
  endif()
endif()

###############################################################################
# enable C++11 and more compiler features

# more template depth for some tests and compilers
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-ftemplate-depth=1024 CXX_HAS_TEMPLATE_DEPTH)
if(CXX_HAS_TEMPLATE_DEPTH)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftemplate-depth=1024")
endif()

# enable C++11
if(MSVC)
  # MSVC 11 or greater has C++11 automatically enabled
elseif(CYGWIN)
  # C++11 is very restrictive on Cygwin
elseif(NOT NO_CXX11)
  # try -std= flags to enable C++11
  check_cxx_compiler_flag(-std=c++11 CXX_HAS_STD_CXX11)
  if(CXX_HAS_STD_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  else()
    check_cxx_compiler_flag(-std=c++0x CXX_HAS_STD_CXX0X)
    if(CXX_HAS_STD_CXX0X)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    endif()
  endif()
endif()

# check C++ compiler for C++11 features

include(CheckCXXSourceCompiles)
check_cxx_source_compiles(
  "#include <vector>
   int main() { std::vector<int> v(42); for (auto i : v) { ++i; } return 0; }"
  STXXL_HAVE_CXX11_RANGE_FOR_LOOP)

###############################################################################
# enable gcov coverage analysis with gcc

if(USE_GCOV)
  # find programs
  find_program(GENHTML genhtml)
  find_program(LCOV lcov)

  if(NOT LCOV OR NOT GENHTML)
    message(SEND_ERROR "Coverage analysis requires lcov and genhtml programs.")
  endif()

  # add coverage anaylsis compile and link flags
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lgcov")

  # custom target to run before tests
  add_custom_target(lcov-reset
    COMMAND ${LCOV} -q --directory ${CMAKE_BINARY_DIR} --zerocounters
    COMMENT "Resetting code coverage counters")

  # custom lcov target to run tests
  add_custom_target(lcov-runtests
    COMMAND ${CMAKE_CTEST_COMMAND} \${ARGS}
    DEPENDS ${ALL_TESTS} lcov-reset
    COMMENT "Running all unit tests")

  # get git version description
  execute_process(COMMAND git describe --tags
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    OUTPUT_VARIABLE GITDESC
    OUTPUT_STRIP_TRAILING_WHITESPACE)

  # command sequence to gather, clean and generate HTML coverage report
  add_custom_target(lcov-html
    COMMAND ${LCOV} -q --directory . --capture --output-file lcov.info
    COMMAND ${LCOV} -q --remove lcov.info 'tests/*' 'examples/*' '/usr/*' --output-file lcov-clean.info
    COMMAND ${GENHTML} -q -o coverage --title "STXXL ${GITDESC}" --prefix ${PROJECT_SOURCE_DIR} --legend lcov-clean.info
    COMMENT "Capturing code coverage counters and create HTML coverage report"
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

  # top-level target to run tests and generate coverage report
  add_custom_target(test-coverage
    COMMENT "Generate HTML coverage report "
    DEPENDS lcov-runtests lcov-html)

endif(USE_GCOV)

###############################################################################
# find thread and random library

# for testing for c++ system include files
include(CheckIncludeFileCXX)

if(MSVC OR USE_STD_THREADS)

  check_include_file_cxx(thread HAVE_STD_THREAD_H)
  check_include_file_cxx(mutex HAVE_STD_MUTEX_H)

  if(HAVE_STD_THREAD_H AND HAVE_STD_MUTEX_H)
    set(STXXL_STD_THREADS "1")
  endif()

  # using <thread> also requires -pthread on gcc
  if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
  endif()

  # also check for <random>
  check_include_file_cxx(random STXXL_STD_RANDOM)

else()
  find_package(Threads REQUIRED)
  set(STXXL_POSIX_THREADS "1")
endif()

###############################################################################
# determine large file support
#     note: these flags need not be exported, all file operations must be
#     encapsulated within the library!

include(TestLargeFiles)
test_large_files(HAVE_LARGEFILES)

if (HAVE_LARGEFILES)
  add_definitions(-D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGE_FILES)
else (NOT HAVE_LARGEFILES)
  message(FATAL_ERROR "Large file support was not detectable.")
endif (HAVE_LARGEFILES)

###############################################################################
# check for O_DIRECT flag

if(CYGWIN)
  #-tb O_DIRECT messes up cygwin
  set(STXXL_DIRECT_IO_OFF 1)
elseif(MSVC)
  # have FILE_FLAG_NO_BUFFERING on Windows
  set(STXXL_DIRECT_IO_OFF 0)
elseif(APPLE)
  # we do not have to test anything, all is well.
  set(STXXL_DIRECT_IO_OFF 0)
else()

  include(CheckCXXSourceCompiles)
  check_cxx_source_compiles("
#include <unistd.h>
#include <fcntl.h>
int main(int argc, char * argv[]) { argc = O_DIRECT; }
" STXXL_HAVE_O_DIRECT)

  if (STXXL_HAVE_O_DIRECT)
    set(STXXL_DIRECT_IO_OFF 0)
  else()
    set(STXXL_DIRECT_IO_OFF 1)
  endif()

endif()

if(STXXL_DIRECT_IO_OFF)
  message(WARNING
    "The open() flag O_DIRECT was disabled!\n"

=== lib/CMakeLists.txt ===
############################################################################
#  lib/CMakeLists.txt
#
#  CMake file for libstxxl.a/so/lib
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

set(LIBSTXXL_SOURCES

  common/cmdline.cpp
  common/exithandler.cpp
  common/log.cpp
  common/rand.cpp
  common/seed.cpp
  common/utils.cpp
  common/verbose.cpp
  common/version.cpp

  io/boostfd_file.cpp
  io/create_file.cpp
  io/disk_queued_file.cpp
  io/file.cpp
  io/fileperblock_file.cpp
  io/iostats.cpp
  io/mem_file.cpp
  io/request.cpp
  io/request_queue_impl_1q.cpp
  io/request_queue_impl_qwqr.cpp
  io/request_queue_impl_worker.cpp
  io/request_with_state.cpp
  io/request_with_waiters.cpp
  io/serving_request.cpp
  io/syscall_file.cpp
  io/ufs_file_base.cpp
  io/wbtl_file.cpp
  io/wfs_file_base.cpp
  io/wincall_file.cpp

  mng/block_manager.cpp
  mng/config.cpp
  mng/disk_allocator.cpp

  algo/async_schedule.cpp

  )

if(NOT MSVC)

  # additional sources for non Visual Studio builds
  set(LIBSTXXL_SOURCES ${LIBSTXXL_SOURCES}

    io/mmap_file.cpp
    io/simdisk_file.cpp

    )

endif(NOT MSVC)

# tell top-level cmakelists which library we build
set(STXXL_EXPORTED_LIBS stxxl)

# we name debug library builds "stxxl_debug" and release builds "stxxl"
string(TOLOWER "stxxl_${CMAKE_BUILD_TYPE}" STXXL_LIBNAME)
if(STXXL_LIBNAME STREQUAL "stxxl_release" OR STXXL_LIBNAME STREQUAL "stxxl_")
  set(STXXL_LIBNAME "stxxl")
endif()

if(BUILD_SHARED_LIBS)

  # build stxxl SHARED library and link all programs again it
  add_library(stxxl SHARED ${LIBSTXXL_SOURCES})
  set_target_properties(stxxl PROPERTIES OUTPUT_NAME "${STXXL_LIBNAME}")
  set_target_properties(stxxl PROPERTIES VERSION "${STXXL_VERSION_STRING}")
  install(TARGETS stxxl
    EXPORT stxxl-targets
    ARCHIVE DESTINATION ${INSTALL_LIB_DIR}
    LIBRARY DESTINATION ${INSTALL_LIB_DIR})

  if(BUILD_STATIC_LIBS)
    # but also build STATIC library
    add_library(stxxl_static STATIC ${LIBSTXXL_SOURCES})
    set_target_properties(stxxl_static PROPERTIES OUTPUT_NAME "${STXXL_LIBNAME}")
    set_target_properties(stxxl_static PROPERTIES VERSION "${STXXL_VERSION_STRING}")
    install(TARGETS stxxl_static
      EXPORT stxxl-targets
      ARCHIVE DESTINATION ${INSTALL_LIB_DIR})

    # we build both shared and static, export both
    set(STXXL_EXPORTED_LIBS stxxl stxxl_static)
  endif()

else()

  if(NOT BUILD_STATIC_LIBS)
    message(FATAL_ERROR "You must build either a static or shared STXXL library")
  endif()

  # build stxxl STATIC library and link all programs again it
  add_library(stxxl STATIC ${LIBSTXXL_SOURCES})
  set_target_properties(stxxl PROPERTIES OUTPUT_NAME "${STXXL_LIBNAME}")
  set_target_properties(stxxl PROPERTIES VERSION "${STXXL_VERSION_STRING}")
  install(TARGETS stxxl
    EXPORT stxxl-targets
    ARCHIVE DESTINATION ${INSTALL_LIB_DIR}
    LIBRARY DESTINATION ${INSTALL_LIB_DIR})

endif()

# export variables to top-level cmakelists
set(STXXL_LIBNAME ${STXXL_LIBNAME} PARENT_SCOPE)
set(STXXL_EXPORTED_LIBS ${STXXL_EXPORTED_LIBS} PARENT_SCOPE)

=== examples/containers/CMakeLists.txt ===
############################################################################
#  examples/containers/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_example(copy_file)
stxxl_build_example(deque1)
stxxl_build_example(deque2)
stxxl_build_example(map1)
stxxl_build_example(matrix1)
stxxl_build_example(pqueue1)
stxxl_build_example(pqueue2)
stxxl_build_example(queue1)
stxxl_build_example(queue2)
stxxl_build_example(sequence1)
stxxl_build_example(sorter1)
stxxl_build_example(sorter2)
stxxl_build_example(stack1)
stxxl_build_example(stack2)
stxxl_build_example(vector1)
stxxl_build_example(vector2)
stxxl_build_example(vector_buf)

stxxl_test(deque1)
stxxl_test(deque2)
stxxl_test(map1)
stxxl_test(matrix1)
stxxl_test(pqueue1)
stxxl_test(pqueue2)
stxxl_test(queue1)
stxxl_test(queue2)
stxxl_test(sequence1)
stxxl_test(sorter1)
stxxl_test(sorter2)
stxxl_test(stack1)
stxxl_test(stack2)
stxxl_test(vector1)
stxxl_test(vector2)
stxxl_test(vector_buf)

=== tests/algo/CMakeLists.txt ===
############################################################################
#  tests/algo/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_test(test_asch)
stxxl_build_test(test_bad_cmp)
stxxl_build_test(test_ksort)
stxxl_build_test(test_random_shuffle)
stxxl_build_test(test_scan)
stxxl_build_test(test_sort)
stxxl_build_test(test_stable_ksort)

add_define(test_bad_cmp "STXXL_VERBOSE_LEVEL=0")
add_define(test_ksort "STXXL_VERBOSE_LEVEL=1" "STXXL_CHECK_ORDER_IN_SORTS")
add_define(test_random_shuffle "STXXL_VERBOSE_LEVEL=0")
add_define(test_sort "STXXL_VERBOSE_LEVEL=0")

stxxl_test(test_asch 3 100 1000 42)
stxxl_test(test_bad_cmp 16)
stxxl_test(test_ksort)
stxxl_test(test_random_shuffle)
stxxl_test(test_scan)
stxxl_test(test_sort)
stxxl_test(test_stable_ksort)

if(NOT CYGWIN AND NOT MINGW) #-tb too big to build on cygwin

  stxxl_build_test(test_ksort_all_parameters)
  stxxl_build_test(test_stable_ksort_all_parameters)
  stxxl_build_test(test_sort_all_parameters)

  add_define(test_ksort_all_parameters "STXXL_VERBOSE_STABLE_KSORT=STXXL_VERBOSE0" "STXXL_VERBOSE_LEVEL=0" "STXXL_CHECK_ORDER_IN_SORTS")

  if(MSVC AND BUILD_TESTS)
    # requires /bigobj flag to build
    set_target_properties(test_ksort_all_parameters PROPERTIES COMPILE_FLAGS /bigobj)
    set_target_properties(test_sort_all_parameters PROPERTIES COMPILE_FLAGS /bigobj)
  endif()

  ### extra sort tests:
  #test_sort_all_parameters         <MiB to sort> <MiB to use> <alloc_strategy [0..3]> <blk_size [0..14]> <seed>
  #test_ksort_all_parameters        <MiB to sort> <MiB to use> <alloc_strategy [0..3]> <blk_size [0..14]> <seed>
  #test_stable_ksort_all_parameters <MiB to sort> <MiB to use> <alloc_strategy [0..3]> <blk_size [0..14]> <seed>
  foreach(DATA 1024)
    foreach(RAM 384)
      foreach(STRATEGY 0 1 2 3)
        foreach(BLK_SIZE 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14)

          stxxl_extra_test(test_sort_all_parameters ${DATA} ${RAM} ${STRATEGY} ${BLK_SIZE} 42)
          stxxl_extra_test(test_ksort_all_parameters ${DATA} ${RAM} ${STRATEGY} ${BLK_SIZE} 42)
          #-tb not fully implemented
          #stxxl_extra_test(test_stable_ksort_all_parameters ${DATA} ${RAM} ${STRATEGY} ${BLK_SIZE} 42)

        endforeach(BLK_SIZE)
      endforeach(STRATEGY)
    endforeach(RAM)
  endforeach(DATA)

  if(NOT BUILD_EXTRAS)

    foreach(STRATEGY 0 1 2 3)
      stxxl_test(test_sort_all_parameters 512 192 ${STRATEGY} 10 42)
      stxxl_test(test_ksort_all_parameters 512 192 ${STRATEGY} 10 42)
      #-tb not fully implemented
      #stxxl_test(test_stable_ksort_all_parameters 512 192 ${STRATEGY} 10 42)
    endforeach(STRATEGY)

  endif(NOT BUILD_EXTRAS)

endif()

if(USE_GNU_PARALLEL)

  stxxl_build_test(test_parallel_sort)

  ### parallel sort tests
  #algo/test_parallel_sort [n in MiB] [p threads] [M in MiB] [sorting algorithm: m | q | qb | s] [merging algorithm: p | s | n]
  foreach(DATA 768)
    foreach(RAM 128)
      foreach(THREADS 1 2 3 4)
        foreach(SORT m q qb s)
          foreach(MERGE p s n)
            stxxl_extra_test(test_parallel_sort ${DATA} ${THREADS} ${RAM} ${SORT} ${MERGE})
          endforeach(MERGE)
        endforeach(SORT)
      endforeach(THREADS)
    endforeach(RAM)
  endforeach(DATA)

  if(NOT BUILD_EXTRAS)

    foreach(SORT m q qb s)
      foreach(MERGE p s n)
        stxxl_test(test_parallel_sort 256 4 96 ${SORT} ${MERGE})
      endforeach(MERGE)
    endforeach(SORT)

  endif(NOT BUILD_EXTRAS)

endif(USE_GNU_PARALLEL)

=== tests/common/CMakeLists.txt ===
############################################################################
#  tests/common/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_test(test_cmdline)
stxxl_build_test(test_counting_ptr)
stxxl_build_test(test_globals)
stxxl_build_test(test_log2)
stxxl_build_test(test_manyunits test_manyunits2)
stxxl_build_test(test_random)
stxxl_build_test(test_tuple)
stxxl_build_test(test_uint_types)

stxxl_test(test_cmdline)
stxxl_test(test_counting_ptr)
stxxl_test(test_globals)
stxxl_test(test_log2)
stxxl_test(test_manyunits)
stxxl_test(test_random)
stxxl_test(test_tuple)
stxxl_test(test_uint_types)

=== tests/containers/CMakeLists.txt ===
############################################################################
#  tests/containers/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

add_subdirectory(btree)

stxxl_build_test(test_deque)
stxxl_build_test(test_ext_merger)
stxxl_build_test(test_ext_merger2)
stxxl_build_test(test_iterators)
stxxl_build_test(test_many_stacks)
stxxl_build_test(test_matrix)
stxxl_build_test(test_migr_stack)
stxxl_build_test(test_pqueue)
stxxl_build_test(test_queue)
stxxl_build_test(test_queue2)
stxxl_build_test(test_sequence)
stxxl_build_test(test_sorter)
stxxl_build_test(test_stack)
stxxl_build_test(test_vector)
stxxl_build_test(test_vector_buf)
stxxl_build_test(test_vector_export)
stxxl_build_test(test_vector_sizes)

stxxl_test(test_deque 3333333)
stxxl_test(test_ext_merger)
stxxl_test(test_ext_merger2)
stxxl_test(test_iterators)
stxxl_test(test_many_stacks 42)
stxxl_test(test_matrix)
stxxl_extra_test(test_matrix --rank 2000)
stxxl_test(test_migr_stack)
stxxl_test(test_pqueue)
stxxl_test(test_queue)
stxxl_test(test_queue2 200)
stxxl_test(test_sequence)
stxxl_test(test_sorter)
stxxl_test(test_stack 1024)
stxxl_test(test_vector)
stxxl_test(test_vector_buf)
stxxl_test(test_vector_export)
stxxl_test(test_vector_sizes "${STXXL_TMPDIR}/out" syscall)
if(STXXL_HAVE_MMAP_FILE)
  stxxl_test(test_vector_sizes "${STXXL_TMPDIR}/out" mmap)
endif(STXXL_HAVE_MMAP_FILE)
if(USE_BOOST)
  #-tb: boostfd does not work right with vector, because boostfd does not
  #correctly support set_size() (truncate and extending of files). FIXME
  #stxxl_test(test_vector_sizes "${STXXL_TMPDIR}/out" boostfd)
endif(USE_BOOST)

# TESTS_MAP
stxxl_build_test(test_map)
stxxl_build_test(test_map_random)

stxxl_test(test_map 12)
stxxl_test(test_map_random 2000)

#-tb longer test for map
stxxl_extra_test(test_map 16)

=== tests/io/CMakeLists.txt ===
############################################################################
#  tests/io/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_test(test_cancel)
stxxl_build_test(test_io)
stxxl_build_test(test_io_sizes)

stxxl_test(test_io "${STXXL_TMPDIR}")

stxxl_test(test_cancel syscall "${STXXL_TMPDIR}/testdisk1")
# FIXME: clean up after fileperblock_syscall
stxxl_test(test_cancel fileperblock_syscall "${STXXL_TMPDIR}/testdisk1")
if(STXXL_HAVE_MMAP_FILE)
  stxxl_test(test_cancel mmap "${STXXL_TMPDIR}/testdisk1")
  stxxl_test(test_cancel fileperblock_mmap "${STXXL_TMPDIR}/testdisk1")
  #-tb: fails randomly (due to I/O cancelation order)
  #stxxl_test(test_cancel simdisk "${STXXL_TMPDIR}/testdisk1")
endif(STXXL_HAVE_MMAP_FILE)
if(USE_BOOST)
  stxxl_test(test_cancel boostfd "${STXXL_TMPDIR}/testdisk1")
  stxxl_test(test_cancel fileperblock_boostfd "${STXXL_TMPDIR}/testdisk1")
endif(USE_BOOST)
stxxl_test(test_cancel memory "${STXXL_TMPDIR}/testdisk1")
# FIXME: asserts!
#stxxl_test(test_cancel wbtl "${STXXL_TMPDIR}/testdisk1")

stxxl_test(test_io_sizes syscall "${STXXL_TMPDIR}/testdisk1" 1073741824)
if(STXXL_HAVE_MMAP_FILE)
  stxxl_test(test_io_sizes mmap "${STXXL_TMPDIR}/testdisk1" 1073741824)
endif(STXXL_HAVE_MMAP_FILE)
if(USE_BOOST)
  stxxl_test(test_io_sizes boostfd "${STXXL_TMPDIR}/testdisk1" 1073741824)
endif(USE_BOOST)

if(STXXL_HAVE_MMAP_FILE)
  stxxl_build_test(test_mmap)
  stxxl_test(test_mmap)
  stxxl_build_test(test_sim_disk)
  # TODO: sometimes asserts due to timing
  #stxxl_test(test_sim_disk)
endif(STXXL_HAVE_MMAP_FILE)

=== tools/benchmarks/CMakeLists.txt ===
############################################################################
#  tools/benchmarks/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_test(benchmark_naive_matrix)
stxxl_build_test(matrix_benchmark)
stxxl_build_test(monotonic_pq)
stxxl_build_test(pq_benchmark)
stxxl_build_test(stack_benchmark)

add_define(benchmark_naive_matrix "STXXL_VERBOSE_LEVEL=0")

if(BUILD_TESTS)
  file(GLOB TPIE_DIR_GLOB RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "tpie_*")

  foreach(TPIE_TEST ${TPIE_DIR_GLOB})
    if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${TPIE_TEST}/lib/libtpie.a")
      set(TPIE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/${TPIE_TEST}")
      break()
    endif()
  endforeach()

  if(EXISTS "${TPIE_DIR}/lib/libtpie.a")

    message("Found compiled TPIE library at ${TPIE_DIR}")

    add_library(tpie STATIC IMPORTED)
    set_property(TARGET tpie PROPERTY IMPORTED_LOCATION "${TPIE_DIR}/lib/libtpie.a")

    include_directories("${TPIE_DIR}/include")

    stxxl_build_test(tpie_stack_benchmark)
    target_link_libraries(tpie_stack_benchmark ${STXXL_LIBRARIES} tpie)

    # try to locate a Berkeley DB version
    find_path(BERKELEYDB_INCLUDES db_cxx.h
      /usr/local/include/db4.8
      /usr/local/include/db4.7
      /usr/local/include/db4.6
      /usr/local/include/db4.5
      /usr/local/include/db4
      /usr/local/include/db
      /usr/include/db4.8
      /usr/include/db4.7
      /usr/include/db4.6
      /usr/include/db4.5
      /usr/include/db4
      /usr/include/db
      )

    find_library(BERKELEYDB_LIBRARIES NAMES db_cxx)

    include(FindPackageHandleStandardArgs)
    find_package_handle_standard_args(BERKELEYDB "Could not find Berkeley DB"
      BERKELEYDB_INCLUDES BERKELEYDB_LIBRARIES)
    mark_as_advanced(BERKELEYDB_INCLUDES BERKELEYDB_LIBRARIES)

    if(BERKELEYDB_FOUND)
      include_directories("${BERKELEYDB_INCLUDES}")

      stxxl_build_test(berkeley_db_benchmark)
      target_link_libraries(berkeley_db_benchmark ${STXXL_LIBRARIES} tpie ${BERKELEYDB_LIBRARIES})
    endif()
  else()
    message("Could not find TPIE, skipping extra benchmarks.")
  endif()
endif(BUILD_TESTS)

=== tools/extras/CMakeLists.txt ===
############################################################################
#  tools/extras/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_extra_tool(benchmark_disk_and_flash)
stxxl_build_extra_tool(iobench_scatter_in_place)
stxxl_build_extra_tool(pq_param)

=== tests/containers/btree/CMakeLists.txt ===
############################################################################
#  tests/containers/btree/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_test(test_btree)
stxxl_build_test(test_const_scan)
stxxl_build_test(test_corr_insert_erase)
stxxl_build_test(test_corr_insert_find)
stxxl_build_test(test_corr_insert_scan)

stxxl_test(test_btree 10000)
stxxl_test(test_btree 100000)
stxxl_test(test_btree 1000000)
stxxl_test(test_const_scan 10000)
stxxl_test(test_const_scan 100000)
stxxl_test(test_const_scan 1000000)
stxxl_test(test_corr_insert_erase 14)
stxxl_test(test_corr_insert_find 14)
stxxl_test(test_corr_insert_scan 14)

=== debian/changelog ===
libstxxl (1.4.0-3) unstable; urgency=medium

  [ Anton Gladky ]
  * [799da84] Add myself to uploaders.
  * [e56aaad] Add autopkgtests.
  * [76dc00f] Simplify debian/rules.
  * [af58c7f] Use wrap-and-sort.

  [ D Haley ]
  * [3d9d2d1] Fix FTBFS for 32 bit via upstream patches (Closes: #75901) 
  * [44d06b0] Relink against system jquery
  * [2618c7f] Remove testing ccache CC/CXX

 -- Anton Gladky <gladk@debian.org>  Sun, 21 Sep 2014 10:39:51 +0200

libstxxl (1.4.0-2) unstable; urgency=medium

  * Team upload.
  * [f08e83e] Revert unstable back to experimental.
  * [1042133] Set canonical VCS-field.
  * [9deb646] Set Standards-Version: 3.9.5. No changes.

 -- Anton Gladky <gladk@debian.org>  Thu, 28 Aug 2014 21:57:17 +0200

libstxxl (1.4.0-1) experimental; urgency=low

  * Update to new upstream

 -- D Haley <mycae@gmx.com>  Sun, 15 Dec 2013 23:44:00 +0100

=== debian/control ===
Source: libstxxl
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 D Haley <mycae@gmx.com>,
 Anton Gladky <gladk@debian.org>
Vcs-Git: git://anonscm.debian.org/debian-science/packages/libstxxl1.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/libstxxl1.git
Build-Depends:
 cmake,
 debhelper (>= 9),
 doxygen,
 doxygen-latex,
 ghostscript,
 graphviz,
 texlive-fonts-extra,
 texlive-fonts-recommended,
 texlive-latex-extra,
 texlive-latex-recommended
Standards-Version: 3.9.5
XS-Testsuite: autopkgtest
Homepage: http://stxxl.sourceforge.net

Package: libstxxl-dev
Section: libdevel
Priority: extra
Depends:
 libstxxl1 (= ${binary:Version}),
 ${misc:Depends}
Suggests:
 libstxxl-doc
Architecture: any
Description: Development libraries for STXXL
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
 .
 Development libraries for STXXL, required for building programs that
 utilise the STXXL library

Package: libstxxl-doc
Section: doc
Priority: extra
Depends:
 ${misc:Depends}, libjs-jquery
Architecture: all
Description: Documentation for STXXL
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
 .
 Documentation for the STXXL library.

Package: libstxxl1
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: C++ Standard Template Library for extra large datasets
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.

Package: libstxxl1-bin
Section: misc
Priority: extra
Depends:
 libstxxl1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Architecture: any
Description: STXXL File creation and benchmark tool
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
 .
 A benchmarking tool and STXXL on-disk file administration utility

Package: libstxxl1-dbg
Section: debug
Priority: extra
Depends:
 libstxxl1 (= ${binary:Version}),
 ${misc:Depends}
Architecture: any
Description: Debugging symbols for STXXL libraries
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
 .
 Debugging symbols for STXXL, required for debugging programs that
 utilise the STXXL library

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3
 http://sf.net/stxxl/stxxl-([0-9].+[0-9])\.tar\.gz
